#import "AppDelegate.h"

@implementation AppDelegate {
    BOOL playerOne;
}

- (const char *)valueForSquare:(NSInteger)square withNewValue:(const char *)value forSquare:(NSInteger)newSquare {
    if (value && square == newSquare) return value;
    return [[[NSUserDefaults standardUserDefaults] stringForKey:[@(square) stringValue]] ?: @"" UTF8String];
}

- (void)relaunchWithNewValueFromButton:(NSButton *)button winningPlayer:(NSString *)player {
    NSInteger target = button ? [button tag] : -1;
    const char *value = button ? (playerOne ? "X" : "O") : NULL;
    const char *path = [[[NSBundle mainBundle] executablePath] fileSystemRepresentation];
    const char * const argv[] = {path,
        "-0", [self valueForSquare:0 withNewValue:value forSquare:target],
        "-1", [self valueForSquare:1 withNewValue:value forSquare:target],
        "-2", [self valueForSquare:2 withNewValue:value forSquare:target],
        "-3", [self valueForSquare:3 withNewValue:value forSquare:target],
        "-4", [self valueForSquare:4 withNewValue:value forSquare:target],
        "-5", [self valueForSquare:5 withNewValue:value forSquare:target],
        "-6", [self valueForSquare:6 withNewValue:value forSquare:target],
        "-7", [self valueForSquare:7 withNewValue:value forSquare:target],
        "-8", [self valueForSquare:8 withNewValue:value forSquare:target],
        "-PlayerTwo", playerOne ? "YES" : "NO",
        "-WinningPlayer", player ? [player UTF8String] : "",
        "-MoveCount", [[@([[NSUserDefaults standardUserDefaults] integerForKey:@"MoveCount"] + 1) stringValue] UTF8String], //lol
        0};
    char *envp[] = {0};
    execve(path, (char * const *)argv, envp);
}

- (NSString *)winningPlayerName {
    return [[NSUserDefaults standardUserDefaults] stringForKey:@"WinningPlayer"] ?: @"";
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    NSString *winningPlayerName = [self winningPlayerName];
    [[self winningPlayerField] setStringValue: winningPlayerName];
    for (NSInteger square = 0; square < 9; square++) {
        NSButton *target = (NSButton *)[[[self window] contentView] viewWithTag:square];
        NSString *value = @([self valueForSquare:square withNewValue:NULL forSquare:-1]);
        [target setTitle:value];
        if ([winningPlayerName length] > 0) {
            [target setEnabled:NO];
        }
    }
    if ([winningPlayerName length] == 0) {
        [self checkForWin];
    }
    playerOne = ![[NSUserDefaults standardUserDefaults] boolForKey:@"PlayerTwo"];
}

- (IBAction)playMove:(id)sender {
    [self relaunchWithNewValueFromButton:(NSButton *)sender winningPlayer:[self winningPlayerName]];
}

- (void) checkForWin {
    //ugly as heck, don't care enough about this part :)
    void (^checkThree) (NSInteger, NSInteger, NSInteger) = ^(NSInteger first, NSInteger second, NSInteger third) {
        if (
            strlen([self valueForSquare:first withNewValue:NULL forSquare:-1]) > 0
            &&
            [@([self valueForSquare:first withNewValue:NULL forSquare:-1]) isEqualToString: @([self valueForSquare:second withNewValue:NULL forSquare:-1])]
            &&
            [@([self valueForSquare:second withNewValue:NULL forSquare:-1]) isEqualToString: @([self valueForSquare:third withNewValue:NULL forSquare:-1])]
            ) {
            [self relaunchWithNewValueFromButton:nil winningPlayer: @([self valueForSquare:first withNewValue:NULL forSquare:-1])];
        }
    };
    checkThree(0, 1, 2);
    checkThree(3, 4, 5);
    checkThree(6, 7, 8);

    checkThree(0, 3, 6);
    checkThree(1, 4, 7);
    checkThree(2, 5, 8);

    checkThree(0, 4, 8);
    checkThree(2, 4, 6);

    if ([[NSUserDefaults standardUserDefaults] integerForKey:@"MoveCount"] == 9) {
        //9 moves and no win, we're done
        for (NSInteger square = 0; square < 9; square++) {
            NSButton *target = (NSButton *)[[[self window] contentView] viewWithTag:square];
            [target setEnabled:NO];
        }
        [[self winningPlayerField] setStringValue:@"Draw"];
    }
}

@end
